#include "settings.h"

directorySettings::directorySettings()
{
	pathDirectory			= NULL;
	pathStats				= NULL;

	reloadSettings();
}

directorySettings::~directorySettings()
{
	deleteStrings();
}

void directorySettings::deleteStrings()
{
	for (int i = 0; i < 10; i++)
	{
		directories[i]   = -1;
	}

	if (pathDirectory)	delete []pathDirectory;
	if (pathStats)		delete []pathStats;
}

void directorySettings::reloadSettings()
{
	deleteStrings();

	// INI file
	char RetBuf[256];
	Uint32 len;

	char Path[532];
	GetCurrentDirectory(520, Path);
	strcat(Path, "\\");
	strcat(Path, INI_NAME);

	len = GetPrivateProfileString("Disk", "Directories", "dirs.txt", RetBuf, 256, Path);

	{
		pathDirectory = new char[len + 1];
		pathDirectory[len] = 0;
		memcpy(RetBuf, pathDirectory, len);
	}

	len = GetPrivateProfileString("Disk", "Statistics", "stats.txt", RetBuf, 256, Path);

	{
		pathStats = new char[len + 1];
		pathStats[len] = 0;
		memcpy(RetBuf, pathStats, len);
	}

	len = GetPrivateProfileString("Ping", "SweepDelay", "200", RetBuf, 256, Path);

	{
		sweepDelay = atoi(RetBuf);
		if (sweepDelay < 10) sweepDelay = 10;
	}

	// dirs.txt
	Uint32 read = 0;
	char * line;
	fileAccess fa;
	fa.open(pathDirectory);

	while ((line = fa.readLine()) && (read < 20))
	{
		directories[read++] = resolveHostname(line);

		delete []line;
	}
}
